unit ConfigMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, Buttons, IniFiles, iShare, ImgList,
  ComCtrls;

type
  TConfigMainForm = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Label5: TLabel;
    EditMyComputerStr: TEdit;
    EditMyNetworkStr: TEdit;
    EditDesktopStr: TEdit;
    TabSheet2: TTabSheet;
    Label6: TLabel;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Label11: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    EditWaitForCheck: TEdit;
    EditWaitForOK: TEdit;
    EditWaitForCabinet: TEdit;
    EditWaitForExplore: TEdit;
    TabSheet3: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    BtnAddAliasToSU: TBitBtn;
    BtnOpenSU: TBitBtn;
    BtnAddAliasToDT: TBitBtn;
    BtnOpenDT: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnOpenSUClick(Sender: TObject);
    procedure BtnOpenDTClick(Sender: TObject);
    procedure BtnAddAliasToSUClick(Sender: TObject);
    procedure BtnAddAliasToDTClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
  private
    procedure   LoadConfig();
    procedure   SaveConfig();
  public

  end;

var
  ConfigMainForm: TConfigMainForm;

implementation

{$R *.dfm}

uses
    iConst;


(*
    =================================================================
    TEdit𐔒lp
    -----------------------------------------------------------------
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=16#0223.txt
    http://www.borland.co.jp/qanda/delphi/d0003457.html
    =================================================================
*)
procedure   SetEditToNumberOnly(AEdit: TEdit; ALength: integer);
var
    WindowLongVal: integer;
begin
    //  l̂ݓ͂
    WindowLongVal := GetWindowLong(AEdit.Handle, GWL_STYLE);
    WindowLongVal := WindowLongVal or ES_NUMBER;
    SetWindowLong(AEdit.Handle, GWL_STYLE, WindowLongVal);
    //  
    PostMessage(AEdit.Handle, EM_LIMITTEXT, ALength, 0);
end;

(*
    =================================================================
    tH[RXgN^
    =================================================================
*)
procedure TConfigMainForm.FormCreate(Sender: TObject);
begin
    //  lp
    SetEditToNumberOnly(EditWaitForCheck  , 3);
    SetEditToNumberOnly(EditWaitForOK     , 3);
    SetEditToNumberOnly(EditWaitForCabinet, 3);
    SetEditToNumberOnly(EditWaitForExplore, 3);
    //  ǂݍ
    LoadConfig();
end;

(*
    =================================================================
    ݒ\
    =================================================================
*)
procedure   TConfigMainForm.LoadConfig();
begin
    EditDesktopStr.Text     := ClickConfig.DeskTop;
    EditMyComputerStr.Text  := ClickConfig.MyComputer;
    EditMyNetworkStr.Text   := ClickConfig.MyNetwork;
    EditWaitForCheck.Text   := IntToStr(ClickConfig.Wait4Check);
    EditWaitForOK.Text      := IntToStr(ClickConfig.Wait4OK);
    EditWaitForCabinet.Text := IntToStr(ClickConfig.Wait4Cabinet);
    EditWaitForExplore.Text := IntToStr(ClickConfig.Wait4Explore);
end;

(*
    =================================================================
    ݒۑ
    =================================================================
*)
procedure   TConfigMainForm.SaveConfig();
begin
    //  \̂ɃZbg
    ClickConfig.DeskTop      := EditDesktopStr.Text;
    ClickConfig.MyComputer   := EditMyComputerStr.Text;
    ClickConfig.MyNetwork    := EditMyNetworkStr.Text;
    ClickConfig.Wait4Check   := StrToInt(EditWaitForCheck.Text);
    ClickConfig.Wait4OK      := StrToInt(EditWaitForOK.Text);
    ClickConfig.Wait4Cabinet := StrToInt(EditWaitForCabinet.Text);
    ClickConfig.Wait4Explore := StrToInt(EditWaitForExplore.Text);
    //  ۑ
    SaveConfiguration();
end;

(*
    =================================================================
    X^[gAbvtH_J
    =================================================================
*)
procedure TConfigMainForm.BtnOpenSUClick(Sender: TObject);
begin
    OpenStartUp();
end;

(*
    =================================================================
    X^[gAbvɓo^
    =================================================================
*)
procedure TConfigMainForm.BtnAddAliasToSUClick(Sender: TObject);
begin
    SendShortCutToStartUp(ParamStr(0));
end;

(*
    =================================================================
    fXNgbvJ
    =================================================================
*)
procedure TConfigMainForm.BtnOpenDTClick(Sender: TObject);
begin
    ToggleDesktopNearly();
end;

(*
    =================================================================
    fXNgbvɃV[gJbg
    =================================================================
*)
procedure TConfigMainForm.BtnAddAliasToDTClick(Sender: TObject);
begin
    SendShortCutToDesktop(ParamStr(0));
end;

(*
    =================================================================
    ۑ{^
    =================================================================
*)
procedure TConfigMainForm.BtnOKClick(Sender: TObject);
begin
    SaveConfig();
    Self.Close();
end;

(*
    =================================================================
    
    =================================================================
*)
procedure TConfigMainForm.BtnCancelClick(Sender: TObject);
begin
    Self.Close();
end;

end.

